#!/bin/bash

if [ "$#" = "1" ]; then
	SED=$1
else
	SED="sed"
fi

TMPDIR=`mktemp -d` || exit 1
SRCFILE="${TMPDIR}/src"
LNKFILE="${TMPDIR}/lnk"

trap "rm -Rf $TMPDIR" EXIT

touch $SRCFILE
if [ $? != 0 ]; then echo "Sanity fail #1"; exit -1; fi
ln -s $SRCFILE $LNKFILE
if [ $? != 0 ]; then echo "Sanity fail #2"; exit -1; fi

S1=`ls -ls $LNKFILE | awk '{print $2}' | cut -b 1`
if [ $? != 0 ]; then echo "Sanity fail #3"; exit -1; fi
${SED} -i 's.o.n.g' $LNKFILE
if [ $? != 0 ]; then echo "Sanity fail #4"; exit -1; fi
S2=`ls -ls $LNKFILE | awk '{print $2}' | cut -b 1`
if [ $? != 0 ]; then echo "Sanity fail #5"; exit -1; fi

if [ "x$S1" != "xl" ]; then
    echo "Sanity fail #6"
    exit -1;
fi

if [ "x$S2" != "xl" ]; then
    echo "Test failed: sed overwrites symlinks." >&2
    exit 2
fi

echo "Test passed." >&2
exit 0
