#!/bin/bash

if [ "$#" = "1" ]; then
	SED=$1
else
	SED="sed"
fi

SRCFILE=`mktemp` || exit 1
TGTFILE=`mktemp` || exit 1

trap "rm -Rf $TMPDIR" EXIT

echo -e "ax\tb" > $SRCFILE
if [ $? != 0 ]; then echo "Sanity fail #1"; exit -1; fi
echo -e "b\txa" > $TGTFILE
if [ $? != 0 ]; then echo "Sanity fail #2"; exit -1; fi

${SED} 'y,ax\tb,b\txa,' < $SRCFILE | diff - $TGTFILE

if [ $? != 0 ]; then
    echo "Test failed: sed doesn't handle escapes." >&2
    exit 2
fi

echo "Test passed." >&2
exit 0
